<?php

declare(strict_types=1);

namespace Dedi\SyliusColissimoPlugin\Controller;

use Dedi\SyliusColissimoPlugin\Domain\ColissimoRelay\UseCase\GetColissimoRelayToken\GetColissimoRelayTokenAction;
use Dedi\SyliusColissimoPlugin\Domain\ColissimoRelay\UseCase\GetColissimoRelayToken\GetColissimoRelayTokenInput;
use Dedi\SyliusColissimoPlugin\Presenter\GetColissimoRelayTokenTwigPresenter;
use Sylius\Component\Core\Model\OrderInterface;
use Sylius\Component\Core\Model\OrderItemInterface;
use Sylius\Component\Order\Context\CartContextInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;

class ColissimoRelayController extends AbstractController
{
    public function __invoke(
        CartContextInterface $cartContext,
        GetColissimoRelayTokenAction $action,
        GetColissimoRelayTokenTwigPresenter $presenter,
        GetColissimoRelayTokenInput $input
    ): Response
    {
        /** @var OrderInterface $cart */
        $cart = $cartContext->getCart();

        $presenter->setWeight(array_reduce($cart->getItems()->toArray(), static function(int $weight, OrderItemInterface $item) {
            return $weight + $item->getVariant()->getWeight();
        }, 0));

        $action($input, $presenter);

        return $this->render('@DediSyliusColissimoPlugin/Shop/_relay.html.twig', array_merge(
            $presenter->getData(),
            ['cart' => $cart]
        ));
    }
}
